
(* Yacc parser template (TP Yacc V3.0), V1.2 6-17-91 AG *)

(* global definitions: *)

uses lexlib, yacclib;

type
    ministring= string [7];
    tipotipo= record
                valor: ministring;
                tipo: integer;
              end;
    tiporegistro= record
                    valor: ministring;
                    case clase: integer of
                         2,3: (tipo: integer);
                         4: (parametro: array [1..5] of integer);
                  end;
    (******   clase:                       tipo:              
           1: constante                tipo simple:      1: integer
           2: tipo                     constructores:    1: array
           3: variable                                   2: puntero
           4: procedimiento
     ******************)

    tipotabla= array [1..100] of tiporegistro;

    tipolista= array [1..20] of integer; 

var
   tabla: tipotabla;  (* Tabla con los identificadores *)
   lista: tipolista;  (* Lista con la posicin de los bloques en la tabla *)
   lin, num, cont: integer;
   actualtabla: integer; (* Posicin de la tabla  *)
   actuallista: integer; (* Posicin de la lista  *)

(************************************************************************)
(*    Introduce un identificador en la tabla                            *)
(************************************************************************)
procedure InsertarTabla (reg: tiporegistro);
begin
     actualtabla:=actualtabla+1;
     tabla[actualtabla]:= reg;
end;

(************************************************************************)
(*    Imprime los valores de la tabla en pantalla                       *)
(************************************************************************)
procedure ImprimirTabla;
var
   i,j : integer;
   aux: string;
begin

     writeln (' *********    TABLA     ***********');
     for i:= 1 to actualtabla do
     begin
          if Tabla[i].clase=4 then
          begin
             write (Tabla[i].valor,'  ',Tabla[i].clase,'  ');
             for j:=1 to 4 do
                 write (Tabla[i].parametro[j]);
             writeln (Tabla[i].parametro[j]);
          end
          else
             writeln (Tabla[i].valor,'  ',Tabla[i].clase,'  ',Tabla[i].tipo);
     end;
end;

(************************************************************************)
(*    Busca un identificador en la tabla y devuelve su tipo             *)
(************************************************************************)
function DevolverTipo (reg: ministring) : integer;
var
   resul, i: integer;
   encontrado: boolean;
begin
     if reg='INTEGER' then
     begin
          resul:=1;
     end
     else
     begin
        i:=actualtabla+1;
        encontrado:=false;
        repeat
              i:=i-1;
              if Tabla[i].valor= reg then
              begin
                   encontrado:=true;
              end;
        until (encontrado) or (i=1);
        if (encontrado) and ((tabla[i].clase=2) or (tabla[i].clase=3) or (tabla[i].clase=1)) then
           resul:= (tabla[i].tipo)
        else
        begin
          if not encontrado then
             writeln ('ERROR: Variable ',reg,' no declarada')
          else
             writeln ('ERROR: Tipo de ',reg,' no vlido');
          halt;
        end;
     end;
     DevolverTipo:= resul;
end;

(************************************************************************)
(*  Busca un identificador en la tabla y devuelve su clase              *)
(************************************************************************)
function DevolverClase (reg: ministring) : integer;
var
   resul, i: integer;
   encontrado: boolean;
begin
     if reg='INTEGER' then
        Resul:= 2
     else
     begin
        i:=actualtabla+1;
        encontrado:=false;
        repeat
           i:=i-1;
           if Tabla[i].valor= reg then
           begin
                encontrado:=true;
           end;
        until (encontrado) or (i=1);
        if (encontrado) and ((tabla[i].clase=2) or (tabla[i].clase=3) or (tabla[i].clase=1)) then
            resul:= (tabla[i].clase)
        else
        begin
            if not encontrado then
                writeln ('ERROR: Variable ',reg,' no declarada')
            else
                writeln ('ERROR: Tipo de ',reg,' no vlido');
                halt;
        end;
     end;
     DevolverClase:= resul;
end;


(************************************************************************)
(*   Pone el tipo de variables ya introducidas en la tabla              *)
(************************************************************************)
procedure PonerTipo (t: integer);
var
   i: integer;
begin
     cont:=cont+1;
     for i:=cont to actualTabla do
        Tabla[i].tipo:= t;
     cont:=actualtabla;
end;

(************************************************************************)
(*   Introduce el tipo de los parametros de un procedimiento            *)
(************************************************************************)
procedure InsertarParam (num: integer; t: integer);
var
   i: integer;
begin
   for i:=1 to num do
   begin
        Tabla[lin].parametro[cont]:=t;
        Tabla[lin+cont].tipo:= t;
        cont:=cont+1;
   end;
end;

(************************************************************************)
(*  Inserta en la tabla los parametros del procedimiento como variables *)
(************************************************************************)
procedure InsertarParTabla (reg: tiporegistro);
begin
     actualtabla:= actualtabla+1;
     Tabla[actualtabla].valor:= reg.valor;
     Tabla[actualtabla].clase:= 3;
end;

(************************************************************************)
(*  Borra un bloque de cdigo de la tabla                               *)
(************************************************************************)
procedure BorrarVariables;
var
   i: integer;
begin
     for i:=lista[actuallista] to actualtabla do
          Tabla[i].valor:='';
     actualtabla:= lista[actuallista]-1;
     lista[actuallista]:=0;
     actuallista:=actuallista-1;
end;

(************************************************************************)
(*Busca el nombre de un procedimiento en la tabla y devuelve su posicin*)
(************************************************************************)
function BuscarProcedimiento(nombre: ministring): integer;
var
   i: integer;
   encontrado: boolean;

begin
     i:= actualtabla+1;
     encontrado:=false;
     repeat
           i:=i-1;
           if (Tabla[i].valor= nombre) and (Tabla[i].clase=4) then
                encontrado:= true;
     until (encontrado) or (i=0);
     if encontrado then
        BuscarProcedimiento:= i
     else
     begin
          writeln ('ERROR: Nombre de procedimiento incorrecto');
          halt;
     end;
end;

(************************************************************************)
(* Comprueba el tipo de los parametros en las llamadas a procedimientos *)
(************************************************************************)
procedure ComprobarTipo (cla, tip: integer);
begin
     if (cla<>1) and (cla<>3) then
     begin
        writeln ('ERROR: Argumento no vlido');
        halt;
     end;
     if tip<>Tabla[num].Parametro[cont] then
     begin
        writeln ('ERROR: Tipo de argumento incorrecto');
        halt;
     end;
     cont:= cont+1;
end;


const _PROGRAM = 257;
const _CONST = 258;
const _TYPE = 259;
const _VAR = 260;
const _ARRAY = 261;
const _OF = 262;
const _PROCEDURE = 263;
const _BEGIN = 264;
const _END = 265;
const PUNTOPUNTO = 266;
const ASIGNACION = 267;
const IDENT = 268;
const ENTERO = 269;

type YYSType = record case Integer of
                 1 : ( yyministring : ministring );
                 2 : ( yytiporegistro : tiporegistro );
                 3 : ( yytipotipo : tipotipo );
               end(*YYSType*);

var yylval : YYSType;

function yylex : Integer; forward;

function yyparse : Integer;

var yystate, yysp, yyn : Integer;
    yys : array [1..yymaxdepth] of Integer;
    yyv : array [1..yymaxdepth] of YYSType;
    yyval : YYSType;

procedure yyaction ( yyruleno : Integer );
  (* local definitions: *)
begin
  (* actions: *)
  case yyruleno of
   1 : begin
         ImprimirTabla
       end;
   2 : begin
         yyv[yysp-0].yytiporegistro.clase:=3; InsertarTabla (yyv[yysp-0].yytiporegistro);
       end;
   3 : begin
         yyv[yysp-0].yytiporegistro.clase:=3; InsertarTabla (yyv[yysp-0].yytiporegistro);
       end;
   4 : begin
         yyval := yyv[yysp-1];
       end;
   5 : begin
       end;
   6 : begin
         yyv[yysp-3].yytiporegistro.clase:=1; yyv[yysp-3].yytiporegistro.tipo:=1; InsertarTabla (yyv[yysp-3].yytiporegistro)
       end;
   7 : begin
         yyv[yysp-3].yytiporegistro.clase:=1; yyv[yysp-3].yytiporegistro.tipo:=1; InsertarTabla (yyv[yysp-3].yytiporegistro)
       end;
   8 : begin
         yyval := yyv[yysp-1];
       end;
   9 : begin
       end;
  10 : begin
         yyv[yysp-3].yytiporegistro.clase:=2;
         yyv[yysp-3].yytiporegistro.tipo:=yyv[yysp-1].yytipotipo.tipo; InsertarTabla (yyv[yysp-3].yytiporegistro)
       end;
  11 : begin
         yyv[yysp-3].yytiporegistro.clase:=2;
         yyv[yysp-3].yytiporegistro.tipo:=yyv[yysp-1].yytipotipo.tipo; InsertarTabla (yyv[yysp-3].yytiporegistro)
       end;
  12 : begin
         yyval.yytipotipo.tipo:= DevolverTipo(yyv[yysp-0].yytiporegistro.valor);
         if DevolverClase (yyv[yysp-0].yytiporegistro.valor)<>2 then begin
         writeln ('ERROR: Debe haber un tipo'); halt; end;
       end;
  13 : begin
         yyval.yytipotipo.tipo:= 1+(3*DevolverTipo(yyv[yysp-0].yytipotipo.valor));
       end;
  14 : begin
         yyval.yytipotipo.tipo:= 2+(3*DevolverTipo(yyv[yysp-0].yytiporegistro.valor));
         if DevolverClase (yyv[yysp-0].yytiporegistro.valor)<>2 then begin
         writeln ('ERROR: Debe haber un tipo'); halt; end;
       end;
  15 : begin
         cont:=actualtabla;
       end;
  16 : begin
         yyval := yyv[yysp-2];
       end;
  17 : begin
       end;
  18 : begin
         PonerTipo (yyv[yysp-1].yytipotipo.tipo);
       end;
  19 : begin
         PonerTipo (yyv[yysp-1].yytipotipo.tipo);
       end;
  20 : begin
         yyval := yyv[yysp-0];
       end;
  21 : begin
       end;
  22 : begin
         yyval := yyv[yysp-1];
       end;
  23 : begin
         yyval := yyv[yysp-0];
       end;
  24 : begin
         yyv[yysp-0].yytiporegistro.clase:=4; InsertarTabla (yyv[yysp-0].yytiporegistro); lin:= actualtabla;
         actuallista:=actuallista+1; lista[actuallista]:=actualtabla+1;
       end;
  25 : begin
         BorrarVariables;
       end;
  26 : begin
         cont:=1
       end;
  27 : begin
         yyval := yyv[yysp-3];
       end;
  28 : begin
         yyval := yyv[yysp-2];
       end;
  29 : begin
         yyval := yyv[yysp-0];
       end;
  30 : begin
         num:=1
       end;
  31 : begin
         InsertarParam (num, yyv[yysp-0].yytipotipo.tipo);
       end;
  32 : begin
         num:=1
       end;
  33 : begin
         InsertarParam (num, yyv[yysp-0].yytipotipo.tipo);
       end;
  34 : begin
         num:=num+1;InsertarParTabla(yyv[yysp-0].yytiporegistro);
       end;
  35 : begin
         InsertarParTabla (yyv[yysp-0].yytiporegistro);
       end;
  36 : begin
         yyval := yyv[yysp-2];
       end;
  37 : begin
         yyval := yyv[yysp-2];
       end;
  38 : begin
         yyval := yyv[yysp-0];
       end;
  39 : begin
         If yyv[yysp-2].yytiporegistro.tipo<>yyv[yysp-0].yytiporegistro.tipo then
         begin write ('ERROR: Asignacin incorrecta');halt; end;
         if yyv[yysp-2].yytiporegistro.clase<>3 then begin write ('ERROR: Debe asignarse a una variable');
         halt; end;
       end;
  40 : begin
         write ('ERROR: Sentencia Incorrecta'); halt;
       end;
  41 : begin
         cont:=1; num:= BuscarProcedimiento(yyv[yysp-0].yytiporegistro.valor);
       end;
  42 : begin
         yyval := yyv[yysp-4];
       end;
  43 : begin
       end;
  44 : begin
         yyval.yytiporegistro.tipo:= DevolverTipo (yyv[yysp-0].yytiporegistro.valor);
         yyval.yytiporegistro.clase:= DevolverClase (yyv[yysp-0].yytiporegistro.valor);
       end;
  45 : begin
         yyval.yytiporegistro.tipo:= yyv[yysp-3].yytiporegistro.tipo div 3;
         If yyv[yysp-1].yytiporegistro.tipo<>1 then begin
         write ('ERROR: Indexacin de array incorrecta'); halt; end;
         yyval.yytiporegistro.clase:= yyv[yysp-3].yytiporegistro.clase;
       end;
  46 : begin
         yyval.yytiporegistro.tipo:= yyv[yysp-1].yytiporegistro.tipo div 3;
         yyval.yytiporegistro.clase:= yyv[yysp-1].yytiporegistro.clase;
       end;
  47 : begin
         yyval.yytiporegistro.tipo:= yyv[yysp-0].yytiporegistro.tipo;
         yyval.yytiporegistro.clase:= yyv[yysp-0].yytiporegistro.clase
       end;
  48 : begin
         yyval.yytiporegistro.tipo:=1; yyval.yytiporegistro.clase:=1;
       end;
  49 : begin
         ComprobarTipo (yyv[yysp-0].yytiporegistro.clase, yyv[yysp-0].yytiporegistro.tipo);
       end;
  50 : begin
         ComprobarTipo (yyv[yysp-0].yytiporegistro.clase, yyv[yysp-0].yytiporegistro.tipo);
       end;
  end;
end(*yyaction*);

(* parse table: *)

type YYARec = record
                sym, act : Integer;
              end;
     YYRRec = record
                len, sym : Integer;
              end;

const

yynacts   = 158;
yyngotos  = 54;
yynstates = 116;
yynrules  = 50;

yya : array [1..yynacts] of YYARec = (
{ 0: }
  ( sym: 257; act: 2 ),
{ 1: }
  ( sym: 0; act: 0 ),
{ 2: }
  ( sym: 268; act: 3 ),
{ 3: }
  ( sym: 40; act: 4 ),
{ 4: }
  ( sym: 268; act: 6 ),
{ 5: }
  ( sym: 41; act: 7 ),
  ( sym: 44; act: 8 ),
{ 6: }
{ 7: }
  ( sym: 59; act: 9 ),
{ 8: }
  ( sym: 268; act: 10 ),
{ 9: }
  ( sym: 258; act: 12 ),
  ( sym: 259; act: -5 ),
  ( sym: 260; act: -5 ),
  ( sym: 263; act: -5 ),
  ( sym: 264; act: -5 ),
{ 10: }
{ 11: }
  ( sym: 259; act: 14 ),
  ( sym: 260; act: -9 ),
  ( sym: 263; act: -9 ),
  ( sym: 264; act: -9 ),
{ 12: }
  ( sym: 268; act: 16 ),
{ 13: }
  ( sym: 260; act: 18 ),
  ( sym: 263; act: -17 ),
  ( sym: 264; act: -17 ),
{ 14: }
  ( sym: 268; act: 20 ),
{ 15: }
  ( sym: 268; act: 21 ),
  ( sym: 259; act: -4 ),
  ( sym: 260; act: -4 ),
  ( sym: 263; act: -4 ),
  ( sym: 264; act: -4 ),
{ 16: }
  ( sym: 61; act: 22 ),
{ 17: }
  ( sym: 263; act: 26 ),
  ( sym: 264; act: -21 ),
{ 18: }
{ 19: }
  ( sym: 268; act: 28 ),
  ( sym: 260; act: -8 ),
  ( sym: 263; act: -8 ),
  ( sym: 264; act: -8 ),
{ 20: }
  ( sym: 61; act: 29 ),
{ 21: }
  ( sym: 61; act: 30 ),
{ 22: }
  ( sym: 269; act: 31 ),
{ 23: }
{ 24: }
  ( sym: 263; act: 26 ),
  ( sym: 264; act: -20 ),
{ 25: }
  ( sym: 264; act: 34 ),
{ 26: }
  ( sym: 268; act: 35 ),
{ 27: }
  ( sym: 268; act: 6 ),
{ 28: }
  ( sym: 61; act: 38 ),
{ 29: }
  ( sym: 94; act: 40 ),
  ( sym: 261; act: 41 ),
  ( sym: 268; act: 42 ),
{ 30: }
  ( sym: 269; act: 43 ),
{ 31: }
  ( sym: 59; act: 44 ),
{ 32: }
{ 33: }
  ( sym: 46; act: 45 ),
{ 34: }
  ( sym: 268; act: 49 ),
  ( sym: 59; act: -43 ),
  ( sym: 265; act: -43 ),
{ 35: }
{ 36: }
  ( sym: 268; act: 6 ),
  ( sym: 263; act: -16 ),
  ( sym: 264; act: -16 ),
{ 37: }
  ( sym: 44; act: 8 ),
  ( sym: 58; act: 52 ),
{ 38: }
  ( sym: 94; act: 40 ),
  ( sym: 261; act: 41 ),
  ( sym: 268; act: 42 ),
{ 39: }
  ( sym: 59; act: 54 ),
{ 40: }
  ( sym: 268; act: 55 ),
{ 41: }
  ( sym: 91; act: 56 ),
{ 42: }
{ 43: }
  ( sym: 59; act: 57 ),
{ 44: }
{ 45: }
{ 46: }
{ 47: }
  ( sym: 59; act: 58 ),
  ( sym: 265; act: 59 ),
{ 48: }
  ( sym: 91; act: 60 ),
  ( sym: 94; act: 61 ),
  ( sym: 267; act: 62 ),
{ 49: }
  ( sym: 59; act: -40 ),
  ( sym: 265; act: -40 ),
  ( sym: 40; act: -41 ),
  ( sym: 91; act: -44 ),
  ( sym: 94; act: -44 ),
  ( sym: 267; act: -44 ),
{ 50: }
{ 51: }
  ( sym: 44; act: 8 ),
  ( sym: 58; act: 66 ),
{ 52: }
  ( sym: 94; act: 40 ),
  ( sym: 261; act: 41 ),
  ( sym: 268; act: 42 ),
{ 53: }
  ( sym: 59; act: 68 ),
{ 54: }
{ 55: }
{ 56: }
  ( sym: 269; act: 69 ),
{ 57: }
{ 58: }
  ( sym: 268; act: 49 ),
  ( sym: 59; act: -43 ),
  ( sym: 265; act: -43 ),
{ 59: }
{ 60: }
  ( sym: 268; act: 73 ),
  ( sym: 269; act: 74 ),
{ 61: }
{ 62: }
  ( sym: 268; act: 73 ),
  ( sym: 269; act: 74 ),
{ 63: }
  ( sym: 40; act: 76 ),
{ 64: }
  ( sym: 40; act: 77 ),
{ 65: }
  ( sym: 59; act: 78 ),
{ 66: }
  ( sym: 94; act: 40 ),
  ( sym: 261; act: 41 ),
  ( sym: 268; act: 42 ),
{ 67: }
  ( sym: 59; act: 80 ),
{ 68: }
{ 69: }
  ( sym: 266; act: 81 ),
{ 70: }
{ 71: }
  ( sym: 93; act: 82 ),
{ 72: }
  ( sym: 91; act: 60 ),
  ( sym: 94; act: 61 ),
  ( sym: 59; act: -47 ),
  ( sym: 93; act: -47 ),
  ( sym: 265; act: -47 ),
{ 73: }
{ 74: }
{ 75: }
{ 76: }
  ( sym: 268; act: 73 ),
{ 77: }
  ( sym: 260; act: 88 ),
  ( sym: 268; act: -32 ),
{ 78: }
  ( sym: 258; act: 12 ),
  ( sym: 259; act: -5 ),
  ( sym: 260; act: -5 ),
  ( sym: 263; act: -5 ),
  ( sym: 264; act: -5 ),
{ 79: }
  ( sym: 59; act: 90 ),
{ 80: }
{ 81: }
  ( sym: 269; act: 91 ),
{ 82: }
{ 83: }
  ( sym: 41; act: 92 ),
  ( sym: 44; act: 93 ),
{ 84: }
  ( sym: 91; act: 60 ),
  ( sym: 94; act: 61 ),
  ( sym: 41; act: -50 ),
  ( sym: 44; act: -50 ),
{ 85: }
  ( sym: 268; act: 95 ),
{ 86: }
{ 87: }
  ( sym: 41; act: 96 ),
  ( sym: 59; act: 97 ),
{ 88: }
{ 89: }
  ( sym: 259; act: 14 ),
  ( sym: 260; act: -9 ),
  ( sym: 263; act: -9 ),
  ( sym: 264; act: -9 ),
{ 90: }
{ 91: }
  ( sym: 93; act: 100 ),
{ 92: }
{ 93: }
  ( sym: 268; act: 73 ),
{ 94: }
  ( sym: 44; act: 102 ),
  ( sym: 58; act: 103 ),
{ 95: }
{ 96: }
{ 97: }
  ( sym: 260; act: 88 ),
  ( sym: 268; act: -32 ),
{ 98: }
  ( sym: 268; act: 95 ),
{ 99: }
  ( sym: 260; act: 18 ),
  ( sym: 263; act: -17 ),
  ( sym: 264; act: -17 ),
{ 100: }
  ( sym: 262; act: 107 ),
{ 101: }
  ( sym: 91; act: 60 ),
  ( sym: 94; act: 61 ),
  ( sym: 41; act: -49 ),
  ( sym: 44; act: -49 ),
{ 102: }
  ( sym: 268; act: 108 ),
{ 103: }
  ( sym: 94; act: 40 ),
  ( sym: 261; act: 41 ),
  ( sym: 268; act: 42 ),
{ 104: }
{ 105: }
  ( sym: 44; act: 102 ),
  ( sym: 58; act: 110 ),
{ 106: }
  ( sym: 263; act: 26 ),
  ( sym: 264; act: -21 ),
{ 107: }
  ( sym: 94; act: 40 ),
  ( sym: 261; act: 41 ),
  ( sym: 268; act: 42 ),
{ 108: }
{ 109: }
{ 110: }
  ( sym: 94; act: 40 ),
  ( sym: 261; act: 41 ),
  ( sym: 268; act: 42 ),
{ 111: }
  ( sym: 264; act: 34 ),
{ 112: }
{ 113: }
{ 114: }
  ( sym: 59; act: 115 )
{ 115: }
);

yyg : array [1..yyngotos] of YYARec = (
{ 0: }
  ( sym: -5; act: 1 ),
{ 1: }
{ 2: }
{ 3: }
{ 4: }
  ( sym: -6; act: 5 ),
{ 5: }
{ 6: }
{ 7: }
{ 8: }
{ 9: }
  ( sym: -7; act: 11 ),
{ 10: }
{ 11: }
  ( sym: -8; act: 13 ),
{ 12: }
  ( sym: -12; act: 15 ),
{ 13: }
  ( sym: -9; act: 17 ),
{ 14: }
  ( sym: -13; act: 19 ),
{ 15: }
{ 16: }
{ 17: }
  ( sym: -17; act: 23 ),
  ( sym: -16; act: 24 ),
  ( sym: -10; act: 25 ),
{ 18: }
  ( sym: -15; act: 27 ),
{ 19: }
{ 20: }
{ 21: }
{ 22: }
{ 23: }
{ 24: }
  ( sym: -17; act: 32 ),
{ 25: }
  ( sym: -11; act: 33 ),
{ 26: }
{ 27: }
  ( sym: -14; act: 36 ),
  ( sym: -6; act: 37 ),
{ 28: }
{ 29: }
  ( sym: -2; act: 39 ),
{ 30: }
{ 31: }
{ 32: }
{ 33: }
{ 34: }
  ( sym: -27; act: 46 ),
  ( sym: -26; act: 47 ),
  ( sym: -3; act: 48 ),
{ 35: }
  ( sym: -19; act: 50 ),
{ 36: }
  ( sym: -6; act: 51 ),
{ 37: }
{ 38: }
  ( sym: -2; act: 53 ),
{ 39: }
{ 40: }
{ 41: }
{ 42: }
{ 43: }
{ 44: }
{ 45: }
{ 46: }
{ 47: }
{ 48: }
{ 49: }
  ( sym: -28; act: 63 ),
{ 50: }
  ( sym: -20; act: 64 ),
  ( sym: -18; act: 65 ),
{ 51: }
{ 52: }
  ( sym: -2; act: 67 ),
{ 53: }
{ 54: }
{ 55: }
{ 56: }
{ 57: }
{ 58: }
  ( sym: -27; act: 70 ),
  ( sym: -3; act: 48 ),
{ 59: }
{ 60: }
  ( sym: -4; act: 71 ),
  ( sym: -3; act: 72 ),
{ 61: }
{ 62: }
  ( sym: -4; act: 75 ),
  ( sym: -3; act: 72 ),
{ 63: }
{ 64: }
{ 65: }
{ 66: }
  ( sym: -2; act: 79 ),
{ 67: }
{ 68: }
{ 69: }
{ 70: }
{ 71: }
{ 72: }
{ 73: }
{ 74: }
{ 75: }
{ 76: }
  ( sym: -29; act: 83 ),
  ( sym: -3; act: 84 ),
{ 77: }
  ( sym: -25; act: 85 ),
  ( sym: -22; act: 86 ),
  ( sym: -21; act: 87 ),
{ 78: }
  ( sym: -7; act: 89 ),
{ 79: }
{ 80: }
{ 81: }
{ 82: }
{ 83: }
{ 84: }
{ 85: }
  ( sym: -23; act: 94 ),
{ 86: }
{ 87: }
{ 88: }
  ( sym: -24; act: 98 ),
{ 89: }
  ( sym: -8; act: 99 ),
{ 90: }
{ 91: }
{ 92: }
{ 93: }
  ( sym: -3; act: 101 ),
{ 94: }
{ 95: }
{ 96: }
{ 97: }
  ( sym: -25; act: 85 ),
  ( sym: -22; act: 104 ),
{ 98: }
  ( sym: -23; act: 105 ),
{ 99: }
  ( sym: -9; act: 106 ),
{ 100: }
{ 101: }
{ 102: }
{ 103: }
  ( sym: -2; act: 109 ),
{ 104: }
{ 105: }
{ 106: }
  ( sym: -17; act: 23 ),
  ( sym: -16; act: 24 ),
  ( sym: -10; act: 111 ),
{ 107: }
  ( sym: -2; act: 112 ),
{ 108: }
{ 109: }
{ 110: }
  ( sym: -2; act: 113 ),
{ 111: }
  ( sym: -11; act: 114 )
{ 112: }
{ 113: }
{ 114: }
{ 115: }
);

yyd : array [0..yynstates-1] of Integer = (
{ 0: } 0,
{ 1: } 0,
{ 2: } 0,
{ 3: } 0,
{ 4: } 0,
{ 5: } 0,
{ 6: } -3,
{ 7: } 0,
{ 8: } 0,
{ 9: } 0,
{ 10: } -2,
{ 11: } 0,
{ 12: } 0,
{ 13: } 0,
{ 14: } 0,
{ 15: } 0,
{ 16: } 0,
{ 17: } 0,
{ 18: } -15,
{ 19: } 0,
{ 20: } 0,
{ 21: } 0,
{ 22: } 0,
{ 23: } -23,
{ 24: } 0,
{ 25: } 0,
{ 26: } 0,
{ 27: } 0,
{ 28: } 0,
{ 29: } 0,
{ 30: } 0,
{ 31: } 0,
{ 32: } -22,
{ 33: } 0,
{ 34: } 0,
{ 35: } -24,
{ 36: } 0,
{ 37: } 0,
{ 38: } 0,
{ 39: } 0,
{ 40: } 0,
{ 41: } 0,
{ 42: } -12,
{ 43: } 0,
{ 44: } -7,
{ 45: } -1,
{ 46: } -38,
{ 47: } 0,
{ 48: } 0,
{ 49: } 0,
{ 50: } -26,
{ 51: } 0,
{ 52: } 0,
{ 53: } 0,
{ 54: } -11,
{ 55: } -14,
{ 56: } 0,
{ 57: } -6,
{ 58: } 0,
{ 59: } -36,
{ 60: } 0,
{ 61: } -46,
{ 62: } 0,
{ 63: } 0,
{ 64: } 0,
{ 65: } 0,
{ 66: } 0,
{ 67: } 0,
{ 68: } -10,
{ 69: } 0,
{ 70: } -37,
{ 71: } 0,
{ 72: } 0,
{ 73: } -44,
{ 74: } -48,
{ 75: } -39,
{ 76: } 0,
{ 77: } 0,
{ 78: } 0,
{ 79: } 0,
{ 80: } -19,
{ 81: } 0,
{ 82: } -45,
{ 83: } 0,
{ 84: } 0,
{ 85: } 0,
{ 86: } -29,
{ 87: } 0,
{ 88: } -30,
{ 89: } 0,
{ 90: } -18,
{ 91: } 0,
{ 92: } -42,
{ 93: } 0,
{ 94: } 0,
{ 95: } -35,
{ 96: } -27,
{ 97: } 0,
{ 98: } 0,
{ 99: } 0,
{ 100: } 0,
{ 101: } 0,
{ 102: } 0,
{ 103: } 0,
{ 104: } -28,
{ 105: } 0,
{ 106: } 0,
{ 107: } 0,
{ 108: } -34,
{ 109: } -33,
{ 110: } 0,
{ 111: } 0,
{ 112: } -13,
{ 113: } -31,
{ 114: } 0,
{ 115: } -25
);

yyal : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 2,
{ 2: } 3,
{ 3: } 4,
{ 4: } 5,
{ 5: } 6,
{ 6: } 8,
{ 7: } 8,
{ 8: } 9,
{ 9: } 10,
{ 10: } 15,
{ 11: } 15,
{ 12: } 19,
{ 13: } 20,
{ 14: } 23,
{ 15: } 24,
{ 16: } 29,
{ 17: } 30,
{ 18: } 32,
{ 19: } 32,
{ 20: } 36,
{ 21: } 37,
{ 22: } 38,
{ 23: } 39,
{ 24: } 39,
{ 25: } 41,
{ 26: } 42,
{ 27: } 43,
{ 28: } 44,
{ 29: } 45,
{ 30: } 48,
{ 31: } 49,
{ 32: } 50,
{ 33: } 50,
{ 34: } 51,
{ 35: } 54,
{ 36: } 54,
{ 37: } 57,
{ 38: } 59,
{ 39: } 62,
{ 40: } 63,
{ 41: } 64,
{ 42: } 65,
{ 43: } 65,
{ 44: } 66,
{ 45: } 66,
{ 46: } 66,
{ 47: } 66,
{ 48: } 68,
{ 49: } 71,
{ 50: } 77,
{ 51: } 77,
{ 52: } 79,
{ 53: } 82,
{ 54: } 83,
{ 55: } 83,
{ 56: } 83,
{ 57: } 84,
{ 58: } 84,
{ 59: } 87,
{ 60: } 87,
{ 61: } 89,
{ 62: } 89,
{ 63: } 91,
{ 64: } 92,
{ 65: } 93,
{ 66: } 94,
{ 67: } 97,
{ 68: } 98,
{ 69: } 98,
{ 70: } 99,
{ 71: } 99,
{ 72: } 100,
{ 73: } 105,
{ 74: } 105,
{ 75: } 105,
{ 76: } 105,
{ 77: } 106,
{ 78: } 108,
{ 79: } 113,
{ 80: } 114,
{ 81: } 114,
{ 82: } 115,
{ 83: } 115,
{ 84: } 117,
{ 85: } 121,
{ 86: } 122,
{ 87: } 122,
{ 88: } 124,
{ 89: } 124,
{ 90: } 128,
{ 91: } 128,
{ 92: } 129,
{ 93: } 129,
{ 94: } 130,
{ 95: } 132,
{ 96: } 132,
{ 97: } 132,
{ 98: } 134,
{ 99: } 135,
{ 100: } 138,
{ 101: } 139,
{ 102: } 143,
{ 103: } 144,
{ 104: } 147,
{ 105: } 147,
{ 106: } 149,
{ 107: } 151,
{ 108: } 154,
{ 109: } 154,
{ 110: } 154,
{ 111: } 157,
{ 112: } 158,
{ 113: } 158,
{ 114: } 158,
{ 115: } 159
);

yyah : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 2,
{ 2: } 3,
{ 3: } 4,
{ 4: } 5,
{ 5: } 7,
{ 6: } 7,
{ 7: } 8,
{ 8: } 9,
{ 9: } 14,
{ 10: } 14,
{ 11: } 18,
{ 12: } 19,
{ 13: } 22,
{ 14: } 23,
{ 15: } 28,
{ 16: } 29,
{ 17: } 31,
{ 18: } 31,
{ 19: } 35,
{ 20: } 36,
{ 21: } 37,
{ 22: } 38,
{ 23: } 38,
{ 24: } 40,
{ 25: } 41,
{ 26: } 42,
{ 27: } 43,
{ 28: } 44,
{ 29: } 47,
{ 30: } 48,
{ 31: } 49,
{ 32: } 49,
{ 33: } 50,
{ 34: } 53,
{ 35: } 53,
{ 36: } 56,
{ 37: } 58,
{ 38: } 61,
{ 39: } 62,
{ 40: } 63,
{ 41: } 64,
{ 42: } 64,
{ 43: } 65,
{ 44: } 65,
{ 45: } 65,
{ 46: } 65,
{ 47: } 67,
{ 48: } 70,
{ 49: } 76,
{ 50: } 76,
{ 51: } 78,
{ 52: } 81,
{ 53: } 82,
{ 54: } 82,
{ 55: } 82,
{ 56: } 83,
{ 57: } 83,
{ 58: } 86,
{ 59: } 86,
{ 60: } 88,
{ 61: } 88,
{ 62: } 90,
{ 63: } 91,
{ 64: } 92,
{ 65: } 93,
{ 66: } 96,
{ 67: } 97,
{ 68: } 97,
{ 69: } 98,
{ 70: } 98,
{ 71: } 99,
{ 72: } 104,
{ 73: } 104,
{ 74: } 104,
{ 75: } 104,
{ 76: } 105,
{ 77: } 107,
{ 78: } 112,
{ 79: } 113,
{ 80: } 113,
{ 81: } 114,
{ 82: } 114,
{ 83: } 116,
{ 84: } 120,
{ 85: } 121,
{ 86: } 121,
{ 87: } 123,
{ 88: } 123,
{ 89: } 127,
{ 90: } 127,
{ 91: } 128,
{ 92: } 128,
{ 93: } 129,
{ 94: } 131,
{ 95: } 131,
{ 96: } 131,
{ 97: } 133,
{ 98: } 134,
{ 99: } 137,
{ 100: } 138,
{ 101: } 142,
{ 102: } 143,
{ 103: } 146,
{ 104: } 146,
{ 105: } 148,
{ 106: } 150,
{ 107: } 153,
{ 108: } 153,
{ 109: } 153,
{ 110: } 156,
{ 111: } 157,
{ 112: } 157,
{ 113: } 157,
{ 114: } 158,
{ 115: } 158
);

yygl : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 2,
{ 2: } 2,
{ 3: } 2,
{ 4: } 2,
{ 5: } 3,
{ 6: } 3,
{ 7: } 3,
{ 8: } 3,
{ 9: } 3,
{ 10: } 4,
{ 11: } 4,
{ 12: } 5,
{ 13: } 6,
{ 14: } 7,
{ 15: } 8,
{ 16: } 8,
{ 17: } 8,
{ 18: } 11,
{ 19: } 12,
{ 20: } 12,
{ 21: } 12,
{ 22: } 12,
{ 23: } 12,
{ 24: } 12,
{ 25: } 13,
{ 26: } 14,
{ 27: } 14,
{ 28: } 16,
{ 29: } 16,
{ 30: } 17,
{ 31: } 17,
{ 32: } 17,
{ 33: } 17,
{ 34: } 17,
{ 35: } 20,
{ 36: } 21,
{ 37: } 22,
{ 38: } 22,
{ 39: } 23,
{ 40: } 23,
{ 41: } 23,
{ 42: } 23,
{ 43: } 23,
{ 44: } 23,
{ 45: } 23,
{ 46: } 23,
{ 47: } 23,
{ 48: } 23,
{ 49: } 23,
{ 50: } 24,
{ 51: } 26,
{ 52: } 26,
{ 53: } 27,
{ 54: } 27,
{ 55: } 27,
{ 56: } 27,
{ 57: } 27,
{ 58: } 27,
{ 59: } 29,
{ 60: } 29,
{ 61: } 31,
{ 62: } 31,
{ 63: } 33,
{ 64: } 33,
{ 65: } 33,
{ 66: } 33,
{ 67: } 34,
{ 68: } 34,
{ 69: } 34,
{ 70: } 34,
{ 71: } 34,
{ 72: } 34,
{ 73: } 34,
{ 74: } 34,
{ 75: } 34,
{ 76: } 34,
{ 77: } 36,
{ 78: } 39,
{ 79: } 40,
{ 80: } 40,
{ 81: } 40,
{ 82: } 40,
{ 83: } 40,
{ 84: } 40,
{ 85: } 40,
{ 86: } 41,
{ 87: } 41,
{ 88: } 41,
{ 89: } 42,
{ 90: } 43,
{ 91: } 43,
{ 92: } 43,
{ 93: } 43,
{ 94: } 44,
{ 95: } 44,
{ 96: } 44,
{ 97: } 44,
{ 98: } 46,
{ 99: } 47,
{ 100: } 48,
{ 101: } 48,
{ 102: } 48,
{ 103: } 48,
{ 104: } 49,
{ 105: } 49,
{ 106: } 49,
{ 107: } 52,
{ 108: } 53,
{ 109: } 53,
{ 110: } 53,
{ 111: } 54,
{ 112: } 55,
{ 113: } 55,
{ 114: } 55,
{ 115: } 55
);

yygh : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 1,
{ 2: } 1,
{ 3: } 1,
{ 4: } 2,
{ 5: } 2,
{ 6: } 2,
{ 7: } 2,
{ 8: } 2,
{ 9: } 3,
{ 10: } 3,
{ 11: } 4,
{ 12: } 5,
{ 13: } 6,
{ 14: } 7,
{ 15: } 7,
{ 16: } 7,
{ 17: } 10,
{ 18: } 11,
{ 19: } 11,
{ 20: } 11,
{ 21: } 11,
{ 22: } 11,
{ 23: } 11,
{ 24: } 12,
{ 25: } 13,
{ 26: } 13,
{ 27: } 15,
{ 28: } 15,
{ 29: } 16,
{ 30: } 16,
{ 31: } 16,
{ 32: } 16,
{ 33: } 16,
{ 34: } 19,
{ 35: } 20,
{ 36: } 21,
{ 37: } 21,
{ 38: } 22,
{ 39: } 22,
{ 40: } 22,
{ 41: } 22,
{ 42: } 22,
{ 43: } 22,
{ 44: } 22,
{ 45: } 22,
{ 46: } 22,
{ 47: } 22,
{ 48: } 22,
{ 49: } 23,
{ 50: } 25,
{ 51: } 25,
{ 52: } 26,
{ 53: } 26,
{ 54: } 26,
{ 55: } 26,
{ 56: } 26,
{ 57: } 26,
{ 58: } 28,
{ 59: } 28,
{ 60: } 30,
{ 61: } 30,
{ 62: } 32,
{ 63: } 32,
{ 64: } 32,
{ 65: } 32,
{ 66: } 33,
{ 67: } 33,
{ 68: } 33,
{ 69: } 33,
{ 70: } 33,
{ 71: } 33,
{ 72: } 33,
{ 73: } 33,
{ 74: } 33,
{ 75: } 33,
{ 76: } 35,
{ 77: } 38,
{ 78: } 39,
{ 79: } 39,
{ 80: } 39,
{ 81: } 39,
{ 82: } 39,
{ 83: } 39,
{ 84: } 39,
{ 85: } 40,
{ 86: } 40,
{ 87: } 40,
{ 88: } 41,
{ 89: } 42,
{ 90: } 42,
{ 91: } 42,
{ 92: } 42,
{ 93: } 43,
{ 94: } 43,
{ 95: } 43,
{ 96: } 43,
{ 97: } 45,
{ 98: } 46,
{ 99: } 47,
{ 100: } 47,
{ 101: } 47,
{ 102: } 47,
{ 103: } 48,
{ 104: } 48,
{ 105: } 48,
{ 106: } 51,
{ 107: } 52,
{ 108: } 52,
{ 109: } 52,
{ 110: } 53,
{ 111: } 54,
{ 112: } 54,
{ 113: } 54,
{ 114: } 54,
{ 115: } 54
);

yyr : array [1..yynrules] of YYRRec = (
{ 1: } ( len: 12; sym: -5 ),
{ 2: } ( len: 3; sym: -6 ),
{ 3: } ( len: 1; sym: -6 ),
{ 4: } ( len: 2; sym: -7 ),
{ 5: } ( len: 0; sym: -7 ),
{ 6: } ( len: 5; sym: -12 ),
{ 7: } ( len: 4; sym: -12 ),
{ 8: } ( len: 2; sym: -8 ),
{ 9: } ( len: 0; sym: -8 ),
{ 10: } ( len: 5; sym: -13 ),
{ 11: } ( len: 4; sym: -13 ),
{ 12: } ( len: 1; sym: -2 ),
{ 13: } ( len: 8; sym: -2 ),
{ 14: } ( len: 2; sym: -2 ),
{ 15: } ( len: 0; sym: -15 ),
{ 16: } ( len: 3; sym: -9 ),
{ 17: } ( len: 0; sym: -9 ),
{ 18: } ( len: 5; sym: -14 ),
{ 19: } ( len: 4; sym: -14 ),
{ 20: } ( len: 1; sym: -10 ),
{ 21: } ( len: 0; sym: -10 ),
{ 22: } ( len: 2; sym: -16 ),
{ 23: } ( len: 1; sym: -16 ),
{ 24: } ( len: 0; sym: -19 ),
{ 25: } ( len: 11; sym: -17 ),
{ 26: } ( len: 0; sym: -20 ),
{ 27: } ( len: 4; sym: -18 ),
{ 28: } ( len: 3; sym: -21 ),
{ 29: } ( len: 1; sym: -21 ),
{ 30: } ( len: 0; sym: -24 ),
{ 31: } ( len: 5; sym: -22 ),
{ 32: } ( len: 0; sym: -25 ),
{ 33: } ( len: 4; sym: -22 ),
{ 34: } ( len: 3; sym: -23 ),
{ 35: } ( len: 1; sym: -23 ),
{ 36: } ( len: 3; sym: -11 ),
{ 37: } ( len: 3; sym: -26 ),
{ 38: } ( len: 1; sym: -26 ),
{ 39: } ( len: 3; sym: -27 ),
{ 40: } ( len: 1; sym: -27 ),
{ 41: } ( len: 0; sym: -28 ),
{ 42: } ( len: 5; sym: -27 ),
{ 43: } ( len: 0; sym: -27 ),
{ 44: } ( len: 1; sym: -3 ),
{ 45: } ( len: 4; sym: -3 ),
{ 46: } ( len: 2; sym: -3 ),
{ 47: } ( len: 1; sym: -4 ),
{ 48: } ( len: 1; sym: -4 ),
{ 49: } ( len: 3; sym: -29 ),
{ 50: } ( len: 1; sym: -29 )
);


const _error = 256; (* error token *)

function yyact(state, sym : Integer; var act : Integer) : Boolean;
  (* search action table *)
  var k : Integer;
  begin
    k := yyal[state];
    while (k<=yyah[state]) and (yya[k].sym<>sym) do inc(k);
    if k>yyah[state] then
      yyact := false
    else
      begin
        act := yya[k].act;
        yyact := true;
      end;
  end(*yyact*);

function yygoto(state, sym : Integer; var nstate : Integer) : Boolean;
  (* search goto table *)
  var k : Integer;
  begin
    k := yygl[state];
    while (k<=yygh[state]) and (yyg[k].sym<>sym) do inc(k);
    if k>yygh[state] then
      yygoto := false
    else
      begin
        nstate := yyg[k].act;
        yygoto := true;
      end;
  end(*yygoto*);

label parse, next, error, errlab, shift, reduce, accept, abort;

begin(*yyparse*)

  (* initialize: *)

  yystate := 0; yychar := -1; yynerrs := 0; yyerrflag := 0; yysp := 0;

{$ifdef yydebug}
  yydebug := true;
{$else}
  yydebug := false;
{$endif}

parse:

  (* push state and value: *)

  inc(yysp);
  if yysp>yymaxdepth then
    begin
      yyerror('yyparse stack overflow');
      goto abort;
    end;
  yys[yysp] := yystate; yyv[yysp] := yyval;

next:

  if (yyd[yystate]=0) and (yychar=-1) then
    (* get next symbol *)
    begin
      yychar := yylex; if yychar<0 then yychar := 0;
    end;

  if yydebug then writeln('state ', yystate, ', char ', yychar);

  (* determine parse action: *)

  yyn := yyd[yystate];
  if yyn<>0 then goto reduce; (* simple state *)

  (* no default action; search parse table *)

  if not yyact(yystate, yychar, yyn) then goto error
  else if yyn>0 then                      goto shift
  else if yyn<0 then                      goto reduce
  else                                    goto accept;

error:

  (* error; start error recovery: *)

  if yyerrflag=0 then yyerror('syntax error');

errlab:

  if yyerrflag=0 then inc(yynerrs);     (* new error *)

  if yyerrflag<=2 then                  (* incomplete recovery; try again *)
    begin
      yyerrflag := 3;
      (* uncover a state with shift action on error token *)
      while (yysp>0) and not ( yyact(yys[yysp], _error, yyn) and
                               (yyn>0) ) do
        begin
          if yydebug then
            if yysp>1 then
              writeln('error recovery pops state ', yys[yysp], ', uncovers ',
                      yys[yysp-1])
            else
              writeln('error recovery fails ... abort');
          dec(yysp);
        end;
      if yysp=0 then goto abort; (* parser has fallen from stack; abort *)
      yystate := yyn;            (* simulate shift on error *)
      goto parse;
    end
  else                                  (* no shift yet; discard symbol *)
    begin
      if yydebug then writeln('error recovery discards char ', yychar);
      if yychar=0 then goto abort; (* end of input; abort *)
      yychar := -1; goto next;     (* clear lookahead char and try again *)
    end;

shift:

  (* go to new state, clear lookahead character: *)

  yystate := yyn; yychar := -1; yyval := yylval;
  if yyerrflag>0 then dec(yyerrflag);

  goto parse;

reduce:

  (* execute action, pop rule from stack, and go to next state: *)

  if yydebug then writeln('reduce ', -yyn);

  yyflag := yyfnone; yyaction(-yyn);
  dec(yysp, yyr[-yyn].len);
  if yygoto(yys[yysp], yyr[-yyn].sym, yyn) then yystate := yyn;

  (* handle action calls to yyaccept, yyabort and yyerror: *)

  case yyflag of
    yyfaccept : goto accept;
    yyfabort  : goto abort;
    yyferror  : goto errlab;
  end;

  goto parse;

accept:

  yyparse := 0; exit;

abort:

  yyparse := 1; exit;

end(*yyparse*);


{$I praclex.pas}

begin
     actualtabla:=0;
     lista[1]:=1;
     actuallista:=1;

     if yyparse=0 then
        writeln ('CORRECTO');
end.